/**
 * 
 */
package com.smansoft;

/**
 * @author SMan
 * 
 */
public class LinesGen {

	/**
	 * 
	 */
	int line[] = null;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int inNum = Integer.parseInt(args[0]);		
		
		System.out.printf("Number = %d\n", inNum);

		LinesGen linesGen = new LinesGen(inNum);
		linesGen.initLine();

		int count = linesGen.procArrayIter();
		System.out.printf("Total count = %d\n", count);
		count = linesGen.procArrayIterBak();
		System.out.printf("Total count = %d\n", count);
		count = linesGen.procArrayRec();
		System.out.printf("Total count = %d\n", count);
	}

	/**
	 * 
	 * @param size
	 */
	public LinesGen(int size) {
		line = new int[size];
	}

	/**
	 * 
	 */
	public void initLine() {
		for (int idx = 0; idx < line.length; idx++) {
			line[idx] = (idx + 1);
		}
	}

	/**
	 * 
	 */
	public void printLine() {
		System.out.print("line = ");
		for (int idx = 0; idx < line.length; idx++) {
			System.out.printf("%d ", line[idx]);
		}
		System.out.println("");
	}

	/**
	 * 
	 * @return
	 */
	public int procArrayRec() {
		int count = 0;
		printLine();
		while (true) {
			count++;
			if (procElem(0) == 0)
				break;
			printLine();
		}
		return count;
	}

	/**
	 * 
	 * @return
	 */
	public int procArrayIter() {
		int idx;
		printLine();
		for (idx = 1; idx < line.length; idx++) {
			for (int idxIn = 0; idxIn <= idx; idxIn++) {
				line[idxIn] = idx + 1;
			}
			printLine();
		}
		return idx;
	}

	/**
	 * 
	 * @return
	 */
	public int procArrayIterBak() {
		int idx;
		printLine();
		for (idx = 1; idx < line.length; idx++) {
			for (int idxIn = 0; idxIn <= (line.length - idx - 1); idxIn++) {
				line[idxIn] = line.length - idx;
			}
			printLine();
		}
		return idx;
	}
	
	/**
	 * 
	 * @param idx
	 * @return
	 */
	private int procElem(int idx) {
		int res = 0;

		if ((idx + 1) >= line.length)
			return 0;

		if (line[idx] >= line[idx + 1])
			res = procElem(idx + 1);
		else
			res = line[idx + 1];

		if (res > 0) {
			line[idx] = res;
			return line[idx];
		} else
			return 0;
	}
}
